diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/bayes.c mrbayes-3.1.2.new/bayes.c
--- mrbayes-3.1.2.old/bayes.c	Fri Dec 23 11:26:28 EST 2005
+++ mrbayes-3.1.2.new/bayes.c	Sat Jul 07 20:06:05 EDT 2007
@@ -692,6 +692,8 @@
 	for (i=0; i<MAX_CHAINS; i++)
 		chainParams.userTemps[i] = 1.0;              /* user-defined chain temperatures               */
 	chainParams.swapAdjacentOnly = NO;               /* swap only adjacent temperatures               */
+	chainParams.useSA = NO; /* whether to try simulated annealing - Allen */
+	chainParams.useAdapt = NO; /* whether to try adapting windows - Allen */
 	chainParams.printMax = 8;						 /* maximum number of chains to print to screen   */
 	chainParams.printAll = YES;						 /* whether to print heated chains                */
 	chainParams.runWithData = YES;				     /* whether to run with data                      */
@@ -916,6 +918,7 @@
 		modelParams[j].covswitchUni[0] = 0.0;
 		modelParams[j].covswitchUni[1] = 100.0;
 		modelParams[j].covswitchExp = 1.0;
+		modelParams[j].covswitchMaxPinvar = 1.0;
 		strcpy(modelParams[j].symPiPr, "Fixed");           /* prior for pi when unidentifiable states used */
 		modelParams[j].symBetaFix = -1.0;
 		modelParams[j].symBetaUni[0] = 0.0;
diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/command.c mrbayes-3.1.2.new/command.c
--- mrbayes-3.1.2.old/command.c	Sun Apr 02 10:47:51 EDT 2006
+++ mrbayes-3.1.2.new/command.c	Sat Jul 07 20:07:18 EDT 2007
@@ -169,7 +169,7 @@
 int				inMrbayesBlock;        /* flag for whether we are in a mrbayes block    */
 int				inSumtBlock;           /* are we in the sumt block                      */
 int				inValidCommand;        /* a useful flag set whenever you enter a cmd    */
-int  			isInAmbig, isInPoly;   /* flags whether we are within () or {}          */
+int  			isInPoly, isInAmbig;   /* flags whether we are within () or {}          */
 int				isTranslateDef;        /* is a translation block defined                */
 int				isUserTreeDefined;     /* flag indicating whether user tree is found    */
 char			logFileName[100];      /* name of the log file                          */
@@ -210,8 +210,8 @@
 int				longIntegerSize;       /* size of an unsigned integer                   */
 
 /* local (to this file) */
-char			*tokenP, token[CMD_STRING_LENGTH];
-CmdType			commands[] =
+static char		*tokenP, token[CMD_STRING_LENGTH];
+static CmdType		commands[] =
 				{
 			/*	Information on commands initialization:
 			 
@@ -224,9 +224,11 @@
 			 		7 = Expecting (2^TokenType) (expect) (PARAMETER = 4; SEMICOLON = 32; ALPHA = 16384; 
 			 		    ALPHA | QUESTIONMARK | DASH | NUMBER | ASTERISK | EXCLAMATIONMARK | PERCENT | WEIRD | SEMICOLON = 11715360;
 			 		    ALPHA | QUESTIONMARK | DASH | NUMBER | ASTERISK | EXCLAMATIONMARK | PERCENT | WEIRD | SEMICOLON | LEFTPAR | RIGHTPAR | LEFTCURL | RIGHTCURL = 112381728;
-			 		    PARAMETER | SEMICOLON = 36; NUMBER | ALPHA = 49152; ALPHA | SEMICOLON = 16416; EQUALSIGN = 8; NUMBER = 32768)
+			PARAMETER | SEMICOLON = 36; NUMBER | ALPHA = 49152; ALPHA | SEMICOLON = 16416; EQUALSIGN = 8;
+			NUMBER = 32768)
 			 		8 = Description of the command (cmdDescription)
-			 		9 = Where should the command be used (cmdUse) (IN_CMD = used from command line or mrbayes block; IN_FILE = used in data block or in tree block)
+			9 = Where should the command be used (cmdUse) (IN_CMD = used from command line or mrbayes block;
+			    IN_FILE = used in data block or in tree block)
 			 	   10 = Should the command be shown when "help" is typed (hiding).
 			 
 			  #1                 #2   #3                 #4  #5                                                                                                #6        #7                                                            #8       #9   #10
@@ -259,10 +261,10 @@
 			{ 25,            "Lset",  NO,            DoLset, 14,                                                     {28,29,30,31,32,33,34,40,51,52,53,91,92,131},        4,                "Sets the parameters of the likelihood model",  IN_CMD, SHOW },
 			{ 26,	       "Manual",  NO,          DoManual,  1,								    														{127},       36,				  "Prints a command reference to a text file",  IN_CMD, SHOW },
 			{ 27,          "Matrix", YES,          DoMatrix,  1,                                                                                             {11},112381728,                 "Defines matrix of characters in data block", IN_FILE, SHOW },
-			{ 28,            "Mcmc",  NO,            DoMcmc, 37,  {17,18,19,20,21,22,23,24,25,26,27,85,99,113,114,115,116,117,132,143,144,145,149,150,151,152,153,
-																														  154,155,156,157,158,159,160,161,167,170},    36,                   "Starts Markov chain Monte Carlo analysis",  IN_CMD, SHOW },
-			{ 29,           "Mcmcp",  NO,           DoMcmcp, 37,  {17,18,19,20,21,22,23,24,25,26,27,85,99,113,114,115,116,117,132,143,144,145,149,150,151,152,153,
-																														  154,155,156,157,158,159,160,161,167,170},        4, "Sets the parameters of a chain (without starting analysis)",  IN_CMD, SHOW },
+			{ 28,            "Mcmc",  NO,            DoMcmc, 39,  {17,18,19,20,21,22,23,24,25,26,27,85,99,113,114,115,116,117,132,143,144,145,149,150,151,152,153,
+																														  154,155,156,157,158,159,160,161,167,170,172,173},    36,                   "Starts Markov chain Monte Carlo analysis",  IN_CMD, SHOW },
+			{ 29,           "Mcmcp",  NO,           DoMcmcp, 39,  {17,18,19,20,21,22,23,24,25,26,27,85,99,113,114,115,116,117,132,143,144,145,149,150,151,152,153,
+																														  154,155,156,157,158,159,160,161,167,170,172,173},        4, "Sets the parameters of a chain (without starting analysis)",  IN_CMD, SHOW },
 			{ 30,        "Outgroup", YES,        DoOutgroup,  1,                                                                                             {79},    49152,                                     "Changes outgroup taxon",  IN_CMD, SHOW },
 			{ 31,           "Pairs", YES,           DoPairs,  1,                                                                                             {93},    32768,        "Defines nucleotide pairs (doublets) for stem models",  IN_CMD, SHOW },
 			{ 32,       "Partition",  NO,       DoPartition,  1,                                                                                             {16},        4,                              "Assigns a character partition",  IN_CMD, SHOW },
@@ -291,14 +293,16 @@
 		/* NOTE: If you add a command here, make certain to change NUMCOMMANDS (above, in this file) appropriately! */
 		    { 999,             NULL,  NO,              NULL,  0,                                                                                             {-1},       32,                                                           "",  IN_CMD, HIDE }  
 		};
-int					inDataBlock, inForeignBlock, isInterleaved, isFirstMatrixRead, isFirstInterleavedBlock, 
-					taxonCount, fromI, toJ, everyK, foundDash, foundSlash, foundFirst, isMixed, whichPartition,
-					isNegative, numPartitions, charOrdering, foundExp, foundColon, isFirstNode, nextAvailableNode,
-					pairId, firstPair;
-char				gapId, missingId, matchId, tempSetName[100];
-CmdType 			*commandPtr;
-ParmInfoPtr			paramPtr;
-TreeNode			*pPtr, *qPtr;
+int                             isMixed, numPartitions; /* also in bayes.c */
+static int			inDataBlock, inForeignBlock, isInterleaved, isFirstMatrixRead, isFirstInterleavedBlock;
+static int                      taxonCount, fromI, toJ, everyK, foundDash, foundSlash, foundFirst, whichPartition;
+static int                      isNegative, charOrdering, foundExp, foundColon, isFirstNode, nextAvailableNode;
+static int                      pairId, firstPair;
+char				gapId, missingId, matchId; /* also in bayes.c - initialized to 'z' */
+static char                     tempSetName[100];
+static CmdType 			*commandPtr;
+static ParmInfoPtr		paramPtr;
+static TreeNode			*pPtr, *qPtr;
 
 
 
@@ -604,16 +608,16 @@
 
 	if (memAllocs[ALLOC_CONSTRAINTNAMES] == YES)
 		goto errorExit;
-	constraintNames = (char *)SafeMalloc((size_t) (30 * 100 * sizeof(char)));
+	constraintNames = (char *)SafeMalloc((size_t) (MAX_NUM_CONSTRAINTS * 100 * sizeof(char)));
 	if (!constraintNames)
 		{
-		MrBayesPrint ("%s   Problem allocating constraintNames (%d)\n", spacer, 3000 * sizeof(char));
+		MrBayesPrint ("%s   Problem allocating constraintNames (%d)\n", spacer, MAX_NUM_CONSTRAINTS * 100 * sizeof(char));
 		goto errorExit;
 		}
-	for (i=0; i<3000; i++)
+	for (i=0; i<(MAX_NUM_CONSTRAINTS*100); i++)
 		{
 		constraintNames[i] = ' ';
-		if (i == (3000 - 1))
+		if (i == ((MAX_NUM_CONSTRAINTS*100) - 1))
 			constraintNames[i] = '\0';
 		}
 	memAllocs[ALLOC_CONSTRAINTNAMES] = YES;
@@ -2298,9 +2302,10 @@
 					return (ERROR);
 					}
 				}
-			else if (numDefinedConstraints > 30)
+			else if (numDefinedConstraints > MAX_NUM_CONSTRAINTS)
 				{
-				MrBayesPrint ("%s   You cannot define more than 30 constraints\n", spacer);
+				MrBayesPrint ("%s   You cannot define more than %d constraints\n", spacer,
+					      MAX_NUM_CONSTRAINTS);
 				return (ERROR);
 				}
 				
@@ -4898,9 +4903,8 @@
 		hasMissingAmbig = NO;
 		for (j=0; j<numTaxa; j++)
 			{
-			if (IsMissing (matrix[pos(j,i,numChar)], charInfo[i].charType) == YES)
-				hasMissingAmbig = YES;
-			if (IsAmbig (matrix[pos(j,i,numChar)], charInfo[i].charType) == YES)
+			if ((IsMissing (matrix[pos(j,i,numChar)], charInfo[i].charType) == YES) ||
+			    (IsAmbig (matrix[pos(j,i,numChar)], charInfo[i].charType) == YES))
 				hasMissingAmbig = YES;
 			}
 		if (hasMissingAmbig == YES)
@@ -5148,7 +5152,7 @@
 					}
 				else
 					{
-					if ((tkn[i] == ')' && isInAmbig == YES) || (tkn[i] == '}' && isInPoly == YES))
+					if ((tkn[i] == ')' && isInPoly == YES) || (tkn[i] == '}' && isInAmbig == YES))
 						{
 						isInAmbig = isInPoly = NO;
 						charCode = theAmbigChar;
@@ -5158,9 +5162,9 @@
 						matrix[pos(taxonCount-1,taxaInfo[taxonCount-1].charCount++,numChar)] = charCode;
 						theAmbigChar = 0;
 						}
-					else if ((tkn[i] == '(' && isInAmbig == YES) || (tkn[i] == '{' && isInPoly == YES))
+					else if ((tkn[i] == '(' && isInPoly == YES) || (tkn[i] == '{' && isInAmbig == YES))
 						{
-						if (isInAmbig == YES)
+						if (isInPoly == YES)
 							MrBayesPrint ("%s   Found an inappropriate \"(\"\n", spacer);
 						else
 							MrBayesPrint ("%s   Found an inappropriate \"{\"\n", spacer);
@@ -5182,18 +5186,13 @@
 						}
 					else if (tkn[i] == '{' && isInPoly == NO && isInAmbig == NO)
 						{
-						isInPoly = YES;
-						matrixHasPoly = YES;
-						theAmbigChar = 0;
-						}	
-					else if (tkn[i] == '(' && isInPoly == NO && isInAmbig == NO)
-						{
 						isInAmbig = YES;
 						theAmbigChar = 0;
 						}
 					else if (tkn[i] == '(' && isInPoly == NO && isInAmbig == NO)
 						{
-						isInAmbig = YES;
+						isInPoly = YES;
+						matrixHasPoly = YES;
 						theAmbigChar = 0;
 						}
 					else
@@ -9194,7 +9193,7 @@
 
 			MrBayesPrint ("   Shapepr          Uniform/Exponential/Fixed    %s", modelParams[i].shapePr);
 			if (!strcmp(modelParams[i].shapePr, "Uniform"))
-				MrBayesPrint ("(%1.1lf,%1.1lf)\n", modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
+				MrBayesPrint ("(%1.3lf,%1.1lf)\n", modelParams[i].shapeUni[0], modelParams[i].shapeUni[1]);
 			else if (!strcmp(modelParams[i].shapePr, "Exponential"))
 				MrBayesPrint ("(%1.1lf)\n", modelParams[i].shapeExp);
 			else
@@ -9212,9 +9211,12 @@
 			else
 				MrBayesPrint ("(%1.1lf)\n", modelParams[i].pInvarFix);
 
-			MrBayesPrint ("   Covswitchpr      Uniform/Exponential/Fixed    %s", modelParams[i].covSwitchPr);
+			MrBayesPrint ("   Covswitchpr      Uniform/PinvarUniform/Exponential/Fixed %s", modelParams[i].covSwitchPr);
 			if (!strcmp(modelParams[i].covSwitchPr, "Uniform"))
 				MrBayesPrint ("(%1.1lf,%1.1lf)\n", modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1]);
+                        else if (!strcmp(modelParams[i].covSwitchPr, "PinvarUniform"))
+				MrBayesPrint ("(%1.1lf,%1.1lf,%1.2f)\n",
+					      modelParams[i].covswitchUni[0], modelParams[i].covswitchUni[1], modelParams[i].covswitchMaxPinvar);
 			else if (!strcmp(modelParams[i].covSwitchPr, "Exponential"))
 				MrBayesPrint ("(%1.1lf)\n", modelParams[i].covswitchExp);
 			else
@@ -9223,7 +9225,7 @@
 			MrBayesPrint ("   Symdirihyperpr   Uniform/Exponential/Fixed    %s", modelParams[i].symPiPr);
 			if (!strcmp(modelParams[i].symPiPr, "Uniform"))
 				MrBayesPrint ("(%1.1lf,%1.1lf)\n", modelParams[i].symBetaUni[0], modelParams[i].symBetaUni[1]);
-			else if (!strcmp(modelParams[i].covSwitchPr, "Exponential"))
+			else if (!strcmp(modelParams[i].symPiPr, "Exponential"))
 				MrBayesPrint ("(%1.1lf)\n", modelParams[i].symBetaExp);
 			else
 				{
@@ -11682,7 +11684,7 @@
 	PARAM   ( 41, "Shapepr",        DoPrsetParm,       "Uniform|Exponential|Fixed|\0");
 	PARAM   ( 42, "Ratecorrpr",     DoPrsetParm,       "Uniform|Fixed|\0");
 	PARAM   ( 43, "Pinvarpr",       DoPrsetParm,       "Uniform|Fixed|\0");
-	PARAM   ( 44, "Covswitchpr",    DoPrsetParm,       "Uniform|Exponential|Fixed|\0");
+	PARAM   ( 44, "Covswitchpr",    DoPrsetParm,       "PinvarUniform|Uniform|Exponential|Fixed|\0");
 	PARAM   ( 45, "Xxxxxxxxxx",     DoExcludeParm,     "\0");
 	PARAM   ( 46, "Xxxxxxxxxx",     DoIncludeParm,     "\0");
 	PARAM   ( 47, "Xxxxxxxxxx",     DoDeleteParm,      "\0");
@@ -11810,6 +11812,8 @@
 	PARAM   (169, "Aarevmatpr",     DoPrsetParm,       "Dirichlet|Fixed|\0");
 	PARAM   (170, "Nswaps",         DoMcmcParm,       "\0");
 	PARAM   (171, "Autooverwrite",  DoSetParm,         "Yes|No|\0");
+	PARAM   (172, "SimAnneal",             DoMcmcParm,       "Yes|No|\0");
+	PARAM   (173, "Adapt",             DoMcmcParm,       "Yes|No|\0");
 	/* NOTE: If a change is made to the parameter table, make certain you
 	         change the number of elements (now 200) in paramTable[] (global.h: may not be necessary 
 	         and at the top of this file). */
diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/Makefile mrbayes-3.1.2.new/Makefile
--- mrbayes-3.1.2.old/Makefile	Sat Mar 25 19:30:51 EST 2006
+++ mrbayes-3.1.2.new/Makefile	Thu Aug 03 20:25:54 EDT 2006
@@ -15,21 +15,28 @@
 
 DEBUG ?= no
 #OPTFLAGS = -O2 -march=pentium4 -mfpmath=sse -fomit-frame-pointers
-OPTFLAGS ?= -O3
+
+# below assumes CFLAGS already set in environment or set below - Allen
+OPTFLAGS ?= -TARG:platform=ip30:processor=r12000
+
+# resetting CFLAGS for debugging - Allen
+#CFLAGS = -g2 -show -TENV:X=1 -LANG:pch=ON:pch_dir=/tmp/allens -DEBUG:subscript_check=ON:verbose_runtime=ON
 
 # set compiler for the non-MPI version (mpicc will be used for the MPI
 # version regardless of this setting)
-CC = gcc
+CC = cc -mips4 -n32 -L/usr/share/rutgers/lib32 -L/usr/lib32/mips4 -L/usr/lib32 -L/lib32 -Wl,-rpath,/usr/share/rutgers/lib32:/usr/lib32/mips4:/usr/lib32:/lib32 -Wl,-multigot -woff 1110 -r12000
 
 # set to yes if you want to use the readline library (make sure you have it
 # installed on your machine)
 # defaults to yes for unix machines
-ifeq ($(strip $(ARCHITECTURE)), unix)
-   USEREADLINE ?= yes
-else
-   USEREADLINE ?= no
-endif
+#ifeq ($(strip $(ARCHITECTURE)), unix)
+#   USEREADLINE ?= yes
+#else
+#   USEREADLINE ?= no
+#endif
 
+USEREADLINE = no
+
 #
 # End of user configuration
 
@@ -63,7 +70,9 @@
 	CFLAGS += $(OPTFLAGS)
 endif
 
-CFLAGS   +=   -Wall 
+# GCC specific, guys! -Allen
+
+#CFLAGS   +=   -Wall 
 
 LIBS     +=   -lm
 
diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mb.h mrbayes-3.1.2.new/mb.h
--- mrbayes-3.1.2.old/mb.h	Sun Mar 26 11:18:31 EST 2006
+++ mrbayes-3.1.2.new/mb.h	Thu Nov 22 12:46:54 EST 2007
@@ -10,8 +10,9 @@
    Makefile file; for compilers not using a project file or Makefile, use the #defines above to select version */
 
 typedef	double MrBFlt;		/* double used for parameter values and generally for floating point values */
-typedef float CLFlt;		/* single-precision float used for cond likes (CLFlt) to increase speed and reduce memory requirement */
+typedef double CLFlt;		/* single-precision float used for cond likes (CLFlt) to increase speed and reduce memory requirement */
 							/* set CLFlt to double if you want increased precision */
+typedef float CLFlt2; /* for things for which increased precision matters less - Allen */
 
 #undef FAST_LOG			/* define this to get a fast polynomial approximation to the log for 4by4 nucleotide data */
 						/* this results in speed gains of 10% to 20% for typical data sets */
@@ -27,13 +28,13 @@
 #undef ICC
 */
 
-#if defined GCC			/* gcc compiler */
-#define ALIGNEDMALLOC memalign
-#elif defined ICC		/* icc compiler */
+#if defined ICC			/* icc compiler */
 #define ALIGNEDMALLOC _mm_malloc
 #elif defined MS_VCPP   /* Visual .Net */
 #define ALIGNEDMALLOC _aligned_malloc
 #include <xmmintrin.h>
+#else  /* Added by Allen Smith */
+#define ALIGNEDMALLOC memalign
 #endif
 
 #ifdef PAUL /* for debugging */
@@ -305,14 +306,18 @@
 #define	P_BRSIGMA				16
 #define	P_GROWTH				17 /* NOTE: If you add another parameter, change NUM_LINKED */
 
-#define	MAX_NUM_DIVS			150
-#define	MAX_NUM_CHARSETS		150
+#define	MAX_NUM_DIVS			256 /* Allen - changed from 150 */
+#define	MAX_NUM_CHARSETS		400 /* Allen - changed from 150 */
 #define	MAX_NUM_PARTITIONS		30
 #define	MAX_NUM_TREES			200
-#define	MAX_NUM_DIV_BITS		150
+#define	MAX_NUM_DIV_BITS		256 /* Allen - changed from 150 */
 #define MAX_NUM_DIV_LONGS       1 + MAX_NUM_DIV_BITS / 32
 #define	MAX_NUM_TAXASETS		30
+#ifdef NOTOPOLOGY /* - Allen */
 #define	MAX_NUM_CONSTRAINTS		30
+#else
+#define	MAX_NUM_CONSTRAINTS		128 /* Allen - changed from 30 */
+#endif
 #define	MAX_CHAINS				256
 
 typedef void * VoidPtr;
@@ -543,6 +548,8 @@
 #define	OMEGA_10FEF						106
 #define	OMEGA_10FFB						107
 #define	OMEGA_10FFF						108
+/* Pinvar limits on Switchrates - Allen */
+#define SWITCH_PINVUNI						109
 
 /* typedef for a MoveFxn */
 typedef int (MoveFxn)(Param *param, int chain, long int *seed, MrBFlt *lnPriorRatio, MrBFlt *lnProposalRatio, MrBFlt *mvp);
@@ -562,7 +569,12 @@
 	MrBFlt		minimum[2];         /* minimum values for tuning params             */
 	MrBFlt		maximum[2];         /* maximum values for tuning params             */
 	int         parsimonyBased;     /* this move is based on parsimony (YES/NO)     */
+	int         doAdaptParam;       /* can use Corana et al sliding window adaptation for this move (YES/NO) */
+	int         whichAdaptParam;  /* which param to adapt - Allen */
+	MrBFlt          minAdaptCFactor;           /* min C-factor to use in adaptation - Allen */
+	int             adaptMultiplier;        /* whether the param to be adapted is a multiplier (YES/NO) - Allen */
 	int         level;              /* user level of this move                      */
+	int         covarion_wanted;    /* 1 if need covarion, -1 if no covarion allowed, 0 if doesn't care - Allen */
 	} MoveType;
 
 
@@ -574,8 +586,7 @@
 /* Note: This allows several different moves to affect the same parameter */
 /* It also allows the same move to affect different parameters as before */
 /* This is also a good place to keep the proposal probs */
-typedef struct
-	{
+typedef struct {
 	char		*name;				/* pointer to the name of the move type         */
 	char		*shortName;	        /* pointer to the short name of the move        */
 	MoveFxn		*moveFxn;			/* pointer to the move function					*/
@@ -584,12 +595,30 @@
 	MrBFlt		cumProposalProb;	/* the cumulative proposal probability			*/
 	int			*nAccepted;			/* number of accepted moves						*/
 	int			*nTried;			/* number of tried moves						*/
+  int             doAdaptParam;           /* can use Corana et al sliding window adaptation for this move (YES/NO) */
+  int             whichAdaptParam;        /* which param to adapt - Allen */
+  int             adaptMultiplier;        /* whether the param to be adapted is a multiplier (YES/NO) - Allen */
+  int             nTriedAfterAdapt;       /* number of times tried after last adapt, if any */
+  int             nAcceptedAfterAdapt;    /* ditto, for accepted */
+  MrBFlt          minAdapt;               /* minimum of adapt param */
+  MrBFlt          minAdaptMult;           /* minimum for multiplier of adapt param before do 2*log(x) */
+  MrBFlt          maxAdapt;               /* maximum of adapt param */
+  MrBFlt          maxAdaptMult;           /* maximum for multiplier of adapt param before do 2*log(x) */
+  MrBFlt          minAdaptCFactor;           /* min C-factor to use in adaptation - Allen */
+  MrBFlt          oldTuningParam;         /* value of adapt param before any adaptation */
+  MrBFlt          oldTuningParamMult;     /* value of adapt param before any adaptation before do 2*log(x) */
+  MrBFlt          minParamTried;           /* min value of adapt param tried */
+  MrBFlt          maxParamTried;           /* max value of adapt param tried */
+  MrBFlt          minParamRefused;        /* min value of adapt param not accepted */
+  MrBFlt          maxParamRefused;        /* max value of adapt param not accepted */
+  MrBFlt          minParamAccepted;       /* min value of adapt param accepted */
+  MrBFlt          maxParamAccepted;       /* max value of adapt param accepted */
 	MrBFlt		tuningParam[2];     /* tuning parameters for the move               */
-	} MCMCMove;
+} MCMCMove;
 
 typedef int (*LikeDownFxn)(TreeNode *, int, int);
 typedef int (*LikeRootFxn)(TreeNode *, int, int);
-typedef int (*LikeScalerFxn)(TreeNode *, int, int);
+typedef int (*LikeScalerFxn)(TreeNode *, int, int, int);
 typedef int (*LikeFxn)(TreeNode *, int, int, MrBFlt *, int);
 typedef int (*TiProbFxn)(TreeNode *, int, int);
 typedef int (*LikeUpFxn)(TreeNode *, int, int);
@@ -698,6 +727,7 @@
 	MrBFlt		covswitchFix[2];
 	MrBFlt		covswitchUni[2];
 	MrBFlt		covswitchExp;
+	MrBFlt		covswitchMaxPinvar; /* maximum ProbOff for covarion - Allen        */
 	char		symPiPr[100];      /* prior for pi when unidentifiable states used */
 	MrBFlt		symBetaFix;
 	MrBFlt		symBetaUni[2];
@@ -714,7 +744,7 @@
 	MrBFlt		brownScalesGammaMean;
 
 	char		topologyPr[100];   /* prior for tree topology                      */
-	int			activeConstraints[30]; 
+	int			activeConstraints[MAX_NUM_CONSTRAINTS]; 
 	int			numActiveConstraints;
 	int			numActiveLocks;
 	char		brlensPr[100];     /* prior on branch lengths                      */
@@ -787,6 +817,8 @@
 	int         diagnFreq;             /* mcmc diagnostics frequency                    */
 	int         relativeBurnin;        /* should a relative burnin be used ?            */
 	MrBFlt      burninFraction;        /* the sample fraction to discard as burnin      */
+	int         useSA; /* flag for whether to use simulated annealing - Allen */
+	int         useAdapt; /* flag for whether to use Corana et al-type adaptation - Allen */
 	int         allComps;              /* top conv diagnosis for all pairs?             */
 	MrBFlt      minPartFreq;           /* minimum partition frequency for conv diagn    */
 	MrBFlt      stopVal;               /* top conv diagn value to reach before stopping */
